SystemOrganization addCategory: #'Magritte-Tutorial'!

Object subclass: #MAAddressModel
	instanceVariableNames: 'street plz place canton nationality'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial'!

!MAAddressModel commentStamp: 'StephaneDucasse 5/17/2015 15:02' prior: 0!
A simple address for a city located in Switzerland.!

!MAAddressModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
= anObject
	^ self species = anObject species
		and: [ self street = anObject street
		and: [ self plz = anObject plz
		and: [ self place = anObject place
		and: [ self canton = anObject canton ] ] ] ]! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
canton
	^ canton! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:53'!
canton: anObject
	canton := anObject! !

!MAAddressModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 15:01'!
descriptionCanton
	<magritteDescription>
	
	^ MASingleOptionDescription new
		options: #( 'Zurich' 'Bern' 'Luzern' 'Uri' 'Schwyz' 'Unterwalden' 'Glarus' 'Zug' 'Freiburg' 'Solothurn' 'Basel' 'Schaffhausen' 'Appenzell' 'St. Gallen' 'Graubunden' 'Aargau' 'Thurgau' 'Ticino' 'Vaud' 'Valais' 'Neuchatel' 'Geneve' 'Jura' );
		reference: MAStringDescription new;
		accessor: #canton;
		label: 'Canton';
		priority: 40;
		beSorted;
		yourself! !

!MAAddressModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 15:01'!
descriptionPlace
	<magritteDescription>
	
	^ MAStringDescription new
			accessor: #place;
			label: 'Place';
			priority: 30;
			yourself! !

!MAAddressModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 15:02'!
descriptionPlz
	<magritteDescription>
	^ MANumberDescription new
		accessor: #plz;
		label: 'PLZ';
		priority: 20;
		min: 1000;
		max: 9999;
		yourself! !

!MAAddressModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 15:02'!
descriptionStreet
	<magritteDescription>
	^ MAStringDescription new
		accessor: #street;
		label: 'Street';
		priority: 10;
		yourself! !

!MAAddressModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
hash
	^ self street hash bitXor: self place hash! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
nationality
	^ nationality! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:53'!
nationality: anObject
	nationality := anObject! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
place
	^ place! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:53'!
place: anObject
	place := anObject! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
plz
	^ plz! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:53'!
plz: anObject
	plz := anObject! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
street
	^ street! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:53'!
street: anObject
	street := anObject! !

Object subclass: #MAPersonModel
	instanceVariableNames: 'title firstName lastName email homeAddress officeAddress picture birthday phones password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial'!

!MAPersonModel commentStamp: 'StephaneDucasse 5/17/2015 15:03' prior: 0!
A simple modle of a person.!

!MAPersonModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
= anObject
	^ self species = anObject species
		and: [ self title = anObject title
		and: [ self firstName = anObject firstName
		and: [ self lastName = anObject lastName
		and: [ self picture = anObject picture
		and: [ self birthday = anObject birthday
		and: [ self officeAddress = anObject officeAddress
		and: [ self homeAddress = anObject homeAddress ] ] ] ] ] ] ]! !

!MAPersonModel methodsFor: 'accessing-calculated' stamp: 'lr 11/29/2006 00:00'!
age
	^ self birthday notNil
		ifTrue: [ Date current year - self birthday year ]! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
birthday
	^ birthday! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
birthday: anObject
	birthday := anObject! !

!MAPersonModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 14:56'!
descriptionAge
	<magritteDescription>
	 ^ MANumberDescription new
		selectorAccessor: #age;
		label: 'Age';
		priority: 80;
		beReadonly;
		yourself! !

!MAPersonModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 14:56'!
descriptionBirthday
	<magritteDescription>
	^ MADateDescription new
		accessor: #birthday;
		label: 'Birthday';
		priority: 70;
		yourself! !

!MAPersonModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 14:57'!
descriptionFirstName
	<magritteDescription>
	
	^ MAStringDescription new
			accessor: #firstName;
			label: 'First Name';
			priority: 20;
			beRequired;
			yourself! !

!MAPersonModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 14:57'!
descriptionHomeAddress
	<magritteDescription>
	
	^ MAToOneRelationDescription new
			componentClass: MAInternalEditorComponent;
			classes: (Array with: MAAddressModel);
			accessor: #homeAddress;
			label: 'Home Address';
			priority: 40;
			yourself! !

!MAPersonModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 14:57'!
descriptionLastName
	<magritteDescription>
	
	^ MAStringDescription new
		accessor: #lastName;
		label: 'Last Name';
		priority: 30;
		beRequired;
		yourself! !

!MAPersonModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 14:58'!
descriptionOfficeAddress
	<magritteDescription>
	
	^ MAToOneRelationDescription new
			componentClass: MAExternalEditorComponent;
			classes: (Array with: MAAddressModel);
			accessor: #officeAddress;
			label: 'Office Address';
			priority: 50;
			yourself! !

!MAPersonModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 14:59'!
descriptionPassword
	<magritteDescription>
	
	^ MAPasswordDescription new
			componentClass: MAVerifiedPasswordComponent;
			accessor: #password;
			label: 'Password';
			priority: 100;
			yourself! !

!MAPersonModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 14:59'!
descriptionPhoneNumbers
	<magritteDescription>
	
	^ MAToManyRelationDescription new
		classes: (Array with: MAPhoneModel);
		label: 'Phone Numbers';
		default: Array new;
		accessor: #phones;
		priority: 90;
		yourself! !

!MAPersonModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 14:59'!
descriptionPicture
	<magritteDescription>
	
	^ MAFileDescription new
		addCondition: [ :value | value isImage ] labelled: 'Image expected';
		accessor: #picture;
		label: 'Picture';
		priority: 60;
		yourself! !

!MAPersonModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 14:59'!
descriptionTitle
	<magritteDescription>
	
	^ MASingleOptionDescription new
			options: #( 'Mr.' 'Mrs.' 'Ms.' 'Miss.' );
			accessor: #title;
			label: 'Title';
			priority: 10;
			yourself! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
email
	^ email! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
email: anObject
	email := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:49'!
firstName
	^ firstName! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
firstName: anObject
	firstName := anObject! !

!MAPersonModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
hash
	^ self firstName hash bitXor: self lastName hash! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
homeAddress
	^ homeAddress! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
homeAddress: anObject
	homeAddress := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
lastName
	^ lastName! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
lastName: anObject
	lastName := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
officeAddress
	^ officeAddress! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
officeAddress: anObject
	officeAddress := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 11/6/2009 15:15'!
password
	^ password! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 11/6/2009 15:15'!
password: aString
	password := aString! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
phones
	^ phones! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
phones: anObject
	phones := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
picture
	^ picture! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
picture: anObject
	picture := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:49'!
title
	^ title! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
title: anObject
	title := anObject! !

Object subclass: #MAPhoneModel
	instanceVariableNames: 'kind number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial'!

!MAPhoneModel commentStamp: 'StephaneDucasse 5/17/2015 15:03' prior: 0!
A simple phone model!

!MAPhoneModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
= anObject
	^ self species = anObject species
		and: [ self kind = anObject kind
		and: [ self number = anObject number ] ]! !

!MAPhoneModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 15:04'!
descriptionKind
	<magritteDescription>
	^ MAStringDescription new
		accessor: #kind;
		label: 'Kind';
		priority: 10;
		yourself! !

!MAPhoneModel methodsFor: 'descriptions' stamp: 'StephaneDucasse 5/17/2015 15:04'!
descriptionNumber
	<magritteDescription>
	
	^ MAStringDescription new
		accessor: #number;
		label: 'Number';
		priority: 20;
		yourself! !

!MAPhoneModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
hash
	^ self kind hash bitXor: self number hash! !

!MAPhoneModel methodsFor: 'accessing' stamp: 'lr 11/28/2006 23:31'!
kind
	^ kind! !

!MAPhoneModel methodsFor: 'accessing' stamp: 'lr 11/28/2006 23:31'!
kind: anObject
	kind := anObject! !

!MAPhoneModel methodsFor: 'accessing' stamp: 'lr 11/28/2006 23:31'!
number
	^ number! !

!MAPhoneModel methodsFor: 'accessing' stamp: 'lr 11/28/2006 23:31'!
number: anObject
	number := anObject! !

WAComponent subclass: #MAPersonEditor
	instanceVariableNames: 'person component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial'!

!MAPersonEditor class methodsFor: 'class initialization' stamp: 'StephaneDucasse 5/17/2015 18:05'!
initialize
	self registerAsApplication: 'personeditor'! !

!MAPersonEditor methodsFor: 'private' stamp: 'StephaneDucasse 5/17/2015 18:04'!
buildComponent
	^ self person asComponent
		addValidatedForm;
		yourself! !

!MAPersonEditor methodsFor: 'hooks' stamp: 'StephaneDucasse 5/17/2015 18:04'!
children
	^ Array with: self component! !

!MAPersonEditor methodsFor: 'accessing' stamp: 'StephaneDucasse 5/17/2015 18:04'!
component
	^ component ifNil: [ component := self buildComponent ]! !

!MAPersonEditor methodsFor: 'accessing' stamp: 'StephaneDucasse 5/17/2015 18:04'!
person
	^ person ifNil: [ person := MAPersonModel new ]! !

!MAPersonEditor methodsFor: 'rendering' stamp: 'StephaneDucasse 5/17/2015 18:04'!
renderContentOn: html
	html heading: 'Edit Person'.
	html render: self component! !
MAPersonEditor initialize!
